<template>
    <form class="bg-grey-lighten-3 rounded-2 p-4 my-7 col-md-10 col-lg-8 col-xxl-7">
        <bs-input name="name" v-model="profile.name" label="Your Name" placeholder="Enter your name"></bs-input>
        <bs-input name="company_name" v-model="profile.company_name" label="Company" placeholder="Enter your company name"></bs-input>
        <bs-input name="job_title" v-model="profile.job_title" label="Job Title" placeholder="Enter your job title"></bs-input>
        <bs-input name="department_name" v-model="profile.department_name" label="Department" placeholder="Enter department name"></bs-input>
        <bs-input name="country" v-model="profile.country" label="Country" placeholder="Select your country" :choices="spec.country.codein" type="select"></bs-input>
    </form>
</template>

<script setup>
import BsInput from "/atila-vue/components/bs-input.vue"

const { state } = useStore ()
const emit = defineEmits (['update:modelValue'])

const spec = backend.get_spec ("EDIT_PROFILES").argspecs.ARGS
const profile = ref ({
  name: '',
  company_name: '',
  job_title: '',
  department_name: '',
  country: '',
})

onMounted (async () => {
  if (state.$uid) {
    const resp = await backend.get ('GET_PROFILES')
    for (let k in resp.data) {
        profile.value [k] = resp.data [k]
    }
  }
})

function validate () {
    if (frontend.validator.failed (profile.value, spec)) {
        return false
    }
    return true
}

async function updateProfile () {
  const resp = await backend.patch ('EDIT_PROFILES', profile.value)
  if (resp.status_code == 701) return
  else if (resp.error) {
    bootstrap.modal ({
      title: "Unable To Upate Profile",
      text: 'Unknown error occured. Please contact us.',
      icon: "error",
      closeButtonText: 'Retry'
    })
    return false
  }
  return true
}

defineExpose ({ updateProfile, validate })

</script>